/*
 *		This Code Was Created By Jeff Molofee and GB Schmick 2000
 *		A HUGE Thanks To Fredric Echols For Cleaning Up
 *		And Optimizing The Base Code, Making It More Flexible!
 *		If You've Found This Code Useful, Please Let Me Know.
 *		Visit Our Sites At www.tiptup.com and nehe.gamedev.net
 */
#include <windows.h>		// Header File For Windows
#include <stdio.h>			// Header File For Standard Input/Output
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include <gl\glext.h>
#include <math.h>
#include <time.h>
#include <vector>
#include <assert.h>

PFNGLCREATEPROGRAMOBJECTARBPROC     glCreateProgramObjectARB = NULL;
PFNGLDELETEOBJECTARBPROC            glDeleteObjectARB = NULL;
PFNGLCREATESHADEROBJECTARBPROC      glCreateShaderObjectARB = NULL;
PFNGLSHADERSOURCEARBPROC            glShaderSourceARB = NULL;
PFNGLCOMPILESHADERARBPROC           glCompileShaderARB = NULL;
PFNGLGETOBJECTPARAMETERIVARBPROC    glGetObjectParameterivARB = NULL;
PFNGLATTACHOBJECTARBPROC            glAttachObjectARB = NULL;
PFNGLGETINFOLOGARBPROC              glGetInfoLogARB = NULL;
PFNGLLINKPROGRAMARBPROC             glLinkProgramARB = NULL;
PFNGLUSEPROGRAMOBJECTARBPROC        glUseProgramObjectARB = NULL;
PFNGLGETUNIFORMLOCATIONARBPROC      glGetUniformLocationARB = NULL;
PFNGLUNIFORM1FARBPROC               glUniform1fARB = NULL;
PFNGLUNIFORM1IARBPROC               glUniform1iARB = NULL;
PFNGLACTIVETEXTUREARBPROC			glActiveTextureARB = NULL;

HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default
bool	light;				// Lighting ON/OFF
bool	lp;					// L Pressed? 
bool	fp;					// F Pressed? 
bool    sp;                 // Spacebar Pressed? ( NEW )
bool    showCylinder=TRUE;	// Draw Cylinder
bool    firstDraw=TRUE;
bool	output = FALSE;
bool    firstTime = TRUE;
int		part1;				// Start Of Disc ( NEW )
int		part2;				// End Of Disc ( NEW )
int		p1=0;				// Increase 1 ( NEW )
int		p2=1;				// Increase 2 ( NEW )
int		vertex = 0;
int		total_vertex = 0;
GLfloat zoomFactor=.87f;			// Zoom factor
GLfloat	ydown=0.0f;				// X Rotation
GLfloat	zrot;				// Z Rotation
GLfloat crot=0.0f;			// Circle rotation
GLfloat xspeed;				// X Rotation Speed
GLfloat zspeed;				// Z Rotation Speed
GLfloat	z=-5.0f;			// Depth Into The Screen
double up = .5;
double out = 47.1;

GLUquadricObj *quadratic;	// Storage For Our Quadratic Objects ( NEW )

GLfloat LightAmbient[]=		{ 0.5f, 0.5f, 0.5f, 1.0f };
GLfloat LightDiffuse[]=		{ 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat LightPosition[]=	{ -2.0f, 0.0f, -2.0f, 1.0f };
GLfloat specular[] =		{1.0f, 1.0f, 1.0f , 1.0f};
GLfloat global_ambient[] =  { 0.5f, 0.0f, 0.0f, 1.0f };

GLuint	filter;				// Which Filter To Use
GLuint	textureNum;			// Storage For 3 Textures
GLuint  displace;		// Storage for 1 Displacement Map
GLuint  object=1;			// Which Object To Draw (NEW)
FILE * file;
FILE * file2; 
FILE * file3;
FILE * file4;
FILE * file5;

#define OUTPUT

double trunk_rad;
double trunk_height;
double trunk_fad;


struct Point3D {
	Point3D() {x = 0; y = 0; z = 0;};
	Point3D(float _x, float _y, float _z) { x = _x; y = _y; z = _z; };
	float x;
	float y;
	float z;
};

struct CylinderObj {
	CylinderObj() { radius = 0; };
	CylinderObj(Point3D _start, Point3D _end, float _radius, float _r_bottom, float _r_top, float _height, float _rotate, float _rotate2, float _translate, float _level) { start = _start; end = _end; radius = _radius; r_bottom = _r_bottom; r_top = _r_top; height = _height; rotate = _rotate; translate = _translate; level = _level; rotate2 = _rotate2;};
	Point3D start;
	Point3D end;
	float radius;
	float height;
	float r_bottom;
	float r_top;
	float rotate;
	float rotate2;
	float translate;
	float dx[11];
	float dy[11];
	float r_dx[100];
	float r_dy[100];
	int level;
};

std::vector<CylinderObj> branches;

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc
void DrawClosedCylinder(float rad_b, float rad_t, float height, float slice, float scale, CylinderObj * obj);
double RandDouble(double, double);

/*
 * Call glNormal3f after scaling normal to unit length.
 */
static void
normal3f(GLfloat x, GLfloat y, GLfloat z)
{
   GLdouble mag;

   mag = sqrt(x * x + y * y + z * z);
   if (mag > 0.00001F) {
      x /= mag;
      y /= mag;
      z /= mag;
   }
   glNormal3f(x, y, z);
}

void 
Cylinder(GLUquadricObj * qobj,
	    GLdouble baseRadius, GLdouble topRadius,
	    GLdouble height, GLint slices, GLint stacks, CylinderObj * obj)
{
   GLdouble da, r, dr, dz;
   GLfloat x, y, z, nz, nsign;
   GLint i, j;

#ifdef OUTPUT
   if(output && firstTime) {
	file = fopen("vertices.txt", "w+");
	file2 = fopen("indices.txt", "w+");
	file3 = fopen("texture.txt", "w+");
	file4 = fopen("normal.txt", "w+");
	file5 = fopen("petals.pbrt", "w+");
	fprintf(file5, "# Translate locations for petal placement\n");
	fprintf(file, "\"point P\" [");
	fprintf(file2, "\"integer indices\" [");
	fprintf(file3, "\"float st\" [");
	fprintf(file4, "\"normal N\" [");
	firstTime = false;
   }
   if(output)
   {
	   vertex = 0;
   }
#endif
   nsign = 1.0;

   da = 2.0 * 3.141592 / slices;
   dr = (topRadius - baseRadius) / stacks;
   dz = height / stacks;
   nz = (baseRadius - topRadius) / height;	/* Z component of normal vectors */

   GLfloat ds = 1.0 / slices;
   GLfloat dt = 1.0 / stacks;
   GLfloat t = 0.0;
   z = 0.0;
   r = baseRadius;
   if(firstDraw) {
	obj->dx[0] = 0;
	obj->dy[0] = 0;
   }

   if(firstDraw)
   {
	   for(int i = 0; i < slices; i++) {
		obj->r_dx[i] = 0;
		obj->r_dy[i] = 0;
	   }
   }
   GLdouble modelview[16];
   glGetDoublev(GL_MODELVIEW_MATRIX, modelview);
   glMatrixMode(GL_MODELVIEW);		
   glPushMatrix();
   glLoadIdentity();
   for (j = 0; j < stacks; j++) {
	 GLfloat s = 0.0;
	 
	 if(firstDraw) {
		if(obj->level < 2)
		{
			obj->dx[j+1] = RandDouble(-baseRadius/8, baseRadius/8);
			obj->dy[j+1] = RandDouble(-baseRadius/8, baseRadius/8);
		}
		else if(obj->level < 5)
		{
			obj->dx[j+1] = RandDouble(-baseRadius /4, baseRadius /4);
			obj->dy[j+1] = RandDouble(-baseRadius /4, baseRadius /4);
		}
		else
		{
			obj->dx[j+1] = RandDouble(-baseRadius * .75, baseRadius * .75);
			obj->dy[j+1] = RandDouble(-baseRadius * .75, baseRadius * .75);
		}
		if(j == stacks-1 || j == stacks-2 || (j%2 == 0 && obj->level != 1 && obj->level < 5)) {
			obj->dx[j+1] = 0;
			obj->dy[j+1] = 0;
		}
	 }
	 glBegin(GL_TRIANGLE_STRIP);
	 for (i = 0; i <= slices; i++) {
	    GLfloat x, y;
	    if (i == slices) {
	       x = sin(0.0);
	       y = cos(0.0);
	    }
	    else {
	       x = sin(i * da);
	       y = cos(i * da);
	    }
		if(firstDraw)
		{
			obj->r_dx[(j+1)*slices + i] = RandDouble(-baseRadius * .2, baseRadius *.2);
			obj->r_dy[(j+1)*slices + i] = RandDouble(-baseRadius * .2, baseRadius *.2);
			if(i == slices || i == (slices - 1) || i == 0 || j < 2)
			{
				obj->r_dx[(j+1)*slices + i] = 0;
				obj->r_dy[(j+1)*slices + i] = 0;
			}
		}
	    normal3f(x * nsign, y * nsign, nz * nsign);
	    glTexCoord2f(s,t);
		double x1 = x*r+ obj->dx[j]+ obj->r_dx[(j)*slices + i];
		double y1 = y*r+ obj->dy[j]+ obj->r_dy[(j)*slices + i];
		double z1 = z;
		double f_x1 = x1 * modelview[0] + y1 * modelview[4] + z1 * modelview[8] + modelview[12];
		double f_y1 = x1 * modelview[1] + y1 * modelview[5] + z1 * modelview[9] + modelview[13];
		double f_z1 = x1 * modelview[2] + y1 * modelview[6] + z1 * modelview[10] + modelview[14];
		double f_w1 = x1 * modelview[3] + y1 * modelview[7] + z1 * modelview[11] + modelview[15];
		
		double x2 = x*(r+dr)+ obj->dx[j+1] + obj->r_dx[(j+1)*slices + i];
		double y2 = y*(r+dr) + obj->dy[j+1]+ obj->r_dy[(j+1)*slices + i];
		double z2 = z+dz;
		double f_x2 = x2 * modelview[0] + y2 * modelview[4] + z2 * modelview[8] + modelview[12];
		double f_y2 = x2 * modelview[1] + y2 * modelview[5] + z2 * modelview[9] + modelview[13];
		double f_z2 = x2 * modelview[2] + y2 * modelview[6] + z2 * modelview[10] + modelview[14];
		double f_w2 = x2 * modelview[3] + y2 * modelview[7] + z2 * modelview[11] + modelview[15];
	
		glVertex3f(f_x1/f_w1, f_y1/f_w1, f_z1/f_w1);
		//glVertex4f(x1, y1, z1, 1);
        //glVertex3f(x * r + obj->dx[j], y * r + obj->dy[j], z);
		normal3f(x * nsign, y * nsign, nz * nsign);
	    glTexCoord2f(s, t + dt);
		//glVertex3f(x * (r + dr) + obj->dx[j+1], y * (r + dr) + obj->dy[j+1], z + dz);
		glVertex3f(f_x2/f_w2, f_y2/f_w2, f_z2/f_w2);
		//glVertex4f(x2, y2, z2, 1);
#ifdef OUTPUT
		if(output)
		{
			
			fprintf(file, "%f %f %f ", f_x1/f_w1, f_y1/f_w1, f_z1/f_w1);
			fprintf(file3, "%f %f ", s, t);
			fprintf(file4, "%f %f %f ", x * nsign, y * nsign, nz * nsign);
			vertex++;
			fprintf(file3, "%f %f ", s, t+dt);
			fprintf(file, "%f %f %f ", f_x2/f_w2, f_y2/f_w2, f_z2/f_w2);
			fprintf(file4, "%f %f %f ", x * nsign, y * nsign, nz * nsign);
			vertex++;
			if(i == slices/2 && j == stacks/2 && obj->level >= 5)
			{	   
				fprintf(file5, "Translate %f %f %f\n", f_x1/f_w1, f_y1/f_w1, f_z1/f_w1);
			}
		}
#endif
	    s += ds;
	}			/* for slices */
	
	glEnd();
	r += dr;
	t += dt;
	z += dz;
  }	/* for stacks */
  glPopMatrix();

#ifdef OUTPUT
   if(output)
   {
	for(int i = total_vertex; i < total_vertex + vertex-2; i++)
	{
		   fprintf(file2, "%d %d %d ", i, i+1, i+2); 
	}
	total_vertex += vertex;
   }
#endif
}

void 
Disk(GLUquadricObj * qobj,
	GLdouble innerRadius, GLdouble outerRadius, GLint slices, GLint loops)
{
   GLfloat da, dr;
#if 0
   GLdouble a, da;
   GLfloat r, dr;
   GLfloat x, y;
   GLfloat r1, r2, dtc;
   GLint s, l;
#endif

#ifdef OUTPUT
   if(output)
   {
	   vertex = 0;
   }
   GLdouble modelview[16];
   glGetDoublev(GL_MODELVIEW_MATRIX, modelview);
   glMatrixMode(GL_MODELVIEW);		
   glPushMatrix();
   glLoadIdentity();

#endif
   glNormal3f(0.0, 0.0, +1.0);

   da = 2.0 * 3.141592 / slices;
   dr = (outerRadius - innerRadius) / (GLfloat) loops;

   	 GLfloat dtc = 2.0f * outerRadius;
	 GLfloat sa, ca;
	 GLfloat r1 = innerRadius;
	 GLint l;
	 for (l = 0; l < loops; l++) {
	    GLfloat r2 = r1 + dr;
	       GLint s;
	       glBegin(GL_TRIANGLE_STRIP);
	       for (s = 0; s <= slices; s++) {
		  GLfloat a;
		  if (s == slices)
		     a = 0.0;
		  else
		     a = s * da;
		  sa = sin(a);
		  ca = cos(a);
		  float s1 = 0.5 + sa * r2 / dtc;
		  float t1 = 0.5 + ca * r2 / dtc;
		  glTexCoord2f(s1, t1);
		  glVertex2f(r2 * sa, r2 * ca);
		  double x1 = r2 * sa;
		  double y1 = r2 * ca;
		  double f_x1 = x1 * modelview[0] + y1 * modelview[4] + modelview[12];
		  double f_y1 = x1 * modelview[1] + y1 * modelview[5] + modelview[13];
		  double f_z1 = 0;
		  double f_w1 = x1 * modelview[3] + y1 * modelview[7] + modelview[15];
		  float s2 = 0.5 + sa * r1 / dtc;
		  float t2 = 0.5 + ca * r1 / dtc;
		  glTexCoord2f(s2, t2);
		  glVertex2f(r1 * sa, r1 * ca);
		  double x2 = r1 * sa;
		  double y2 = r1 * ca;
		  double f_x2 = x2 * modelview[0] + y2 * modelview[4] + modelview[12];
		  double f_y2 = x2 * modelview[1] + y2 * modelview[5] + modelview[13];
		  double f_z2 = 0;
		  double f_w2 = x2 * modelview[3] + y2 * modelview[7] + modelview[15];
		  
#ifdef OUTPUT
		if(output)
		{
			
			fprintf(file, "%f %f %f ", f_x1/f_w1, f_y1/f_w1, f_z1/f_w1);
			fprintf(file3, "%f %f ", s1, t1);
			fprintf(file4, "%f %f %f ", 0.001, 0.001, 1);
			vertex++;
			fprintf(file3, "%f %f ", s2, t2);
			fprintf(file, "%f %f %f ", f_x2/f_w2, f_y2/f_w2, f_z2/f_w2);
			fprintf(file4, "%f %f %f ", 0.001, 0.001, 1);
			vertex++;
		}
#endif
	       }
	       glEnd();
	    r1 = r2;
	 }
	glPopMatrix();
#ifdef OUTPUT
   if(output)
   {
	for(int i = total_vertex; i < total_vertex + vertex-2; i++)
	{
		   fprintf(file2, "%d %d %d ", i, i+1, i+2); 
	}
	total_vertex += vertex;
   }
#endif
}

AUX_RGBImageRec *LoadBMP(char *Filename)				// Loads A Bitmap Image
{
	FILE *File=NULL;									// File Handle

	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}

	File=fopen(Filename,"r");							// Check To See If The File Exists

	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}

	return NULL;										// If Load Failed Return NULL
}

int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture
	AUX_RGBImageRec *DisplaceImage[1];

	memset(TextureImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (TextureImage[0]=LoadBMP("Data/Wall.bmp"))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(1, &textureNum);					// Create Three Textures

		// Create Linear Filtered Texture
		//glActiveTextureARB(GL_TEXTURE0_ARB);
		
		glEnable(GL_TEXTURE_2D);

		/*int width, height;
		unsigned char data[256 * 256 * 3];
		FILE * tex_file = fopen("texmap.txt", "w+");
		// texture data
		width = 256;
		height = 256;

		for(int i = 0; i < width; i++)
		{
			for(int j = 0; j < height; j++)
			{
				data[i * height * 3 + j * 3 + 0] = (unsigned char)(150.0f);
				data[i * height * 3 + j * 3 + 1] = (unsigned char)(200.0f);
				data[i * height * 3 + j * 3 + 2] = (unsigned char)(10.0f);
			}
		}
		int size = fwrite( data, 1, width * height * 3, tex_file );
		fclose(tex_file);*/

		glBindTexture(GL_TEXTURE_2D, textureNum);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		//glTexImage2D(GL_TEXTURE_2D, 0, 3, width, height, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
		glEnable(GL_TEXTURE_2D);
		
	}

	if (TextureImage[0])								// If Texture Exists
	{
		if (TextureImage[0]->data)						// If Texture Image Exists
		{
			free(TextureImage[0]->data);				// Free The Texture Image Memory
		}

		free(TextureImage[0]);							// Free The Image Structure
	}

	memset(DisplaceImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	/*if (DisplaceImage[0]=LoadBMP("Data/Displace.bmp"))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(1, &displace);					// Create Three Textures

		// Create Nearest Filtered Texture
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glBindTexture(GL_TEXTURE_2D, displace);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, DisplaceImage[0]->sizeX, DisplaceImage[0]->sizeY, 0, GL_RGBA_FLOAT32_ATI, GL_UNSIGNED_BYTE, DisplaceImage[0]->data);
		glEnable(GL_TEXTURE_2D);

	}

	if (DisplaceImage[0])								// If Texture Exists
	{
		if (DisplaceImage[0]->data)						// If Texture Image Exists
		{
			free(DisplaceImage[0]->data);				// Free The Texture Image Memory
		}

		free(DisplaceImage[0]);							// Free The Image Structure
	}
*/
	return Status;										// Return The Status
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

double RandDouble()
{
	return (   (double)rand() / ((double)(RAND_MAX)+(double)(1)) );
}

double RandDouble(double start, double end)
{
	return RandDouble() * (end - start) + start;
}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	glActiveTextureARB = (PFNGLACTIVETEXTUREARBPROC)	 
		wglGetProcAddress("glActiveTextureARB");
	if (!LoadGLTextures())								// Jump To Texture Loading Routine
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}

	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(1.0f, 1.0f, 1.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);					// Set Line Antialiasing

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
	glLightfv(GL_LIGHT1, GL_SPECULAR, specular);
	glEnable(GL_LIGHT1);								// Enable Light One
	glEnable(GL_LIGHTING);

	quadratic=gluNewQuadric();							// Create A Pointer To The Quadric Object (Return 0 If No Memory) (NEW)
	gluQuadricNormals(quadratic, GLU_SMOOTH);			// Create Smooth Normals (NEW)
	
	gluQuadricTexture(quadratic, GL_TRUE);				// Create Texture Coords (NEW)
	gluQuadricDrawStyle( quadratic, GLU_LINE );		// Set drawing style

	glCreateProgramObjectARB = (PFNGLCREATEPROGRAMOBJECTARBPROC)
      wglGetProcAddress("glCreateProgramObjectARB");
    glDeleteObjectARB = (PFNGLDELETEOBJECTARBPROC)
      wglGetProcAddress("glDeleteObjectARB");
    glCreateShaderObjectARB = (PFNGLCREATESHADEROBJECTARBPROC)
     wglGetProcAddress("glCreateShaderObjectARB");
    glShaderSourceARB = (PFNGLSHADERSOURCEARBPROC)
      wglGetProcAddress("glShaderSourceARB");
    glCompileShaderARB = (PFNGLCOMPILESHADERARBPROC)
      wglGetProcAddress("glCompileShaderARB");
    glGetObjectParameterivARB = (PFNGLGETOBJECTPARAMETERIVARBPROC)
      wglGetProcAddress("glGetObjectParameterivARB");
    glAttachObjectARB = (PFNGLATTACHOBJECTARBPROC)
      wglGetProcAddress("glAttachObjectARB");
    glGetInfoLogARB = (PFNGLGETINFOLOGARBPROC)
      wglGetProcAddress("glGetInfoLogARB");
    glLinkProgramARB = (PFNGLLINKPROGRAMARBPROC)
      wglGetProcAddress("glLinkProgramARB");
    glUseProgramObjectARB = (PFNGLUSEPROGRAMOBJECTARBPROC)
      wglGetProcAddress("glUseProgramObjectARB");
    glGetUniformLocationARB = (PFNGLGETUNIFORMLOCATIONARBPROC)
      wglGetProcAddress("glGetUniformLocationARB");
    glUniform1fARB = (PFNGLUNIFORM1FARBPROC)
      wglGetProcAddress("glUniform1fARB");
    glUniform1iARB = (PFNGLUNIFORM1IARBPROC)
      wglGetProcAddress("glUniform1iARB");
	//glGetObjectParameteriv = (PFNGLGETOBJECTPARAMETERIVARBPROC) wglGetProcAddress("glGetObjectParameteriv");

	const char * vertex_shader_source = 
		"uniform sampler2D displacementMap;\n"
		"void main(void)\n"
		"{\n"
		"vec4 newVertexPos;\n"
		"vec4 dv;\n"
		"float df;\n"
		"gl_TexCoord[0].xy = gl_MultiTexCoord0.xy;\n"
		"dv = texture2D( displacementMap, gl_MultiTexCoord0.xy );\n"
		"df = 0.30*dv.x + 0.59*dv.y + 0.11*dv.z;\n"
		"newVertexPos = vec4(gl_Normal * 1 * df, 0.0) + gl_Vertex;\n"
		"gl_Position = gl_ModelViewProjectionMatrix * newVertexPos;\n"
		"}\n";

	const char * pixel_shader_source = 
		"uniform sampler2D colorMap;\n"
		"void main(void)\n"
		"{\n"
		"gl_FragColor = texture2D(colorMap, gl_TexCoord[0].xy);\n"
		//"gl_FragColor = vec4(0.4,0.4,0.8,1.0);\n"
		"}\n";

	GLuint program;
	GLuint vertex_shader;
	GLuint pixel_shader;

	// Create Shader And Program Objects
	program = glCreateProgramObjectARB();
	vertex_shader = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	pixel_shader = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);

	// Load Shader Sources
	glShaderSourceARB(vertex_shader, 1, &vertex_shader_source, NULL);
	glShaderSourceARB(pixel_shader, 1, &pixel_shader_source, NULL);
	
	// Compile The Shaders
	//glCompileShaderARB(vertex_shader);
	//glCompileShaderARB(pixel_shader);

	GLint compiled = false;

	//glGetObjectParameteriv(vertex_shader, GL_COMPILE_STATUS, &compiled);
	if (compiled)
	{
		fprintf(stderr, "Compiled!\n");
	}      

	// Attach The Shader Objects To The Program Object
	//glAttachObjectARB(program, vertex_shader);
	glAttachObjectARB(program, pixel_shader);

	// Link The Program Object
	glLinkProgramARB(program);

	// Use The Program Object Instead Of Fixed Function OpenGL
	glUseProgramObjectARB(program);

	char infobuffer[1000];
	int infobufferlen = 0;
	glGetInfoLogARB(vertex_shader, 999, &infobufferlen, infobuffer);
	infobuffer[infobufferlen] = 0;
	
	char infobuffer2[1000];
	int infobufferlen2 = 0;
	glGetInfoLogARB(pixel_shader, 999, &infobufferlen2, infobuffer2);
	infobuffer2[infobufferlen2] = 0;

	GLint uniform_location2;
	uniform_location2 = glGetUniformLocationARB(program, "colorMap");
	glUniform1iARB(uniform_location2, 0);
	
	GLint uniform_location;
	uniform_location = glGetUniformLocationARB(program, "displacementMap");
	glUniform1iARB(uniform_location, 1);

	srand ( time(NULL) );
	// Set random value for trunk radius
	trunk_rad = RandDouble(1.7, 2.0);
	// Ratio of trunk height to trunk radius
	trunk_height = RandDouble(8, 10) * (trunk_rad / 2);
	// Shrinking of trunk from bottom to top
	trunk_fad = RandDouble(.8, .9);  // .3 to .8 
	ydown = -18;
	return TRUE;										// Initialization Went OK
}

void DrawSubBranch(float radius, float height, int level, int branchnum, int total_branches)
{
	if(radius < .03 || level == 7) return;
	glPushMatrix();
	glTranslatef(0, 0, -height);
	float alpha, alpha2;
	if(level <= 4)
	{
		if(branchnum)
			alpha = RandDouble(10,30);
		else
			alpha = RandDouble(-30, -10);
		glRotatef(alpha, 0, 1, 0);

		int side = (int) RandDouble(0, 2);
		if(side)
			alpha2 = RandDouble(10,40);
		else
			alpha2 = RandDouble(-40, -10);
		glRotatef(alpha2, 1, 0, 0);
	}
	else {
		if(branchnum < total_branches/2) {
		float init = -150;
		float end = -10;
		float range = end - init;
		float per_range = range / total_branches/2;
		alpha = RandDouble(init + per_range * branchnum, init + per_range * (branchnum + 1));
		}
		else{
		float init = 10;
		float end = 150;
		float range = end - init;
		float per_range = range / total_branches/2;
		alpha = RandDouble(init + per_range * (branchnum - total_branches/2), init + per_range * (branchnum - total_branches/2 + 1));
		}
		glRotatef(alpha, 0, 1, 0);

		if(branchnum < total_branches/2) {
		float init = -150;
		float end = -10;
		float range = end - init;
		float per_range = range / total_branches/2;
		alpha2 = RandDouble(init + per_range * branchnum, init + per_range * (branchnum + 1));
		}
		else{
		float init = 10;
		float end = 150;
		float range = end - init;
		float per_range = range / total_branches/2;
		alpha2 = RandDouble(init + per_range * (branchnum - total_branches/2), init + per_range * (branchnum - total_branches/2 + 1));
		}
		glRotatef(alpha2, 1, 0, 0);
	}

	float height_val = RandDouble(8, 16);
	float branch_height = height_val * radius;
	float init_fad;
	float branch_fad;
	if(level == 2) {
		height_val = RandDouble(6, 12);
		branch_height = height_val * radius;
		branch_fad = 1 - (((height_val - 6) / 6) / 2 + .1);
		if(branch_fad < 0) branch_fad = 0;
		init_fad = 1;
	}
	else if(level <= 4) {
		height_val = RandDouble(6, 12);
		branch_height = height_val * radius;
		branch_fad = 1 - (((height_val - 6) / 6) /4 + .1);
		if(branch_fad < 0) branch_fad = 0;
		init_fad = 1;
	}
	else {
		branch_fad = RandDouble(.3, .5);
		init_fad = RandDouble(.8, .9);
	}

	Point3D start(0, 0, height);
	Point3D end(0, 0, height+branch_height);
	CylinderObj branch(start, end, init_fad * radius, init_fad * radius, branch_fad * radius, branch_height, alpha, alpha2, -height, level);

	DrawClosedCylinder(init_fad * radius, branch_fad * radius, branch_height, 7, 7, &branch);
	branches.push_back(branch);
	int branches;
	if(level == 2)
		branches = (int) RandDouble(2, 2);
	else if (level <= 4)
		branches = (int) RandDouble(3, 4);
	else if (level <= 6)
		branches = (int) RandDouble(2, 6);
	else
		branches = (int) RandDouble(1, 4);
	for(int i = 0; i < branches; i++) {
		float loc = RandDouble(.5, .95);
		if(level <= 3)
			loc = 1;
		float b_radius = init_fad * radius - (1-branch_fad)*init_fad*radius*loc;
		if(level <= 3)
			DrawSubBranch(b_radius, (1-loc)*branch_height, level + 1, i, 2);
		else
			DrawSubBranch(b_radius, (1-loc)*branch_height, level + 1, i, branches);
	}
	glPopMatrix();		
}

void DrawBranch(float radius, float height, int branchnum)
{
	if(radius < .01) return;
	glPushMatrix();
	glTranslatef(0, 0, -height);
	float alpha;
	if(branchnum)
		alpha = RandDouble(10,20);
	else
		alpha = RandDouble(-20, -10);
	glRotatef(alpha, 0, 1, 0);
	
	float alpha2;
	int side = (int) RandDouble(0, 2);
	if(side)
		alpha2 = RandDouble(10,20);
	else
		alpha2 = RandDouble(-20, -10);
	alpha2 = 0;
	glRotatef(alpha2, 1, 0, 0);
	
	float height_val = RandDouble(8, 24);
	float branch_height = height_val * radius / 2;
	float branch_fad = 1 - (((height_val - 8) / 16)/2 + .3);
	
	// Add branch to collision set
	Point3D start(0, 0, height);
	Point3D end(0, 0, height+branch_height);
	CylinderObj branch(start, end, radius, radius, branch_fad * radius, branch_height, alpha, alpha2, -height, 1);

	// Draw branch
	DrawClosedCylinder(radius, branch_fad * radius, branch_height, 7, 7, &branch);
	branches.push_back(branch);

	// Draw sub-branches
	int branches = (int) RandDouble(2, 2);
	for(int i = 0; i < branches; i++) {
		//float loc = RandDouble(0.9, 1);
		float loc = 1;
		float b_radius = branch_fad * radius;
		DrawSubBranch(b_radius, (1-loc)*branch_height, 2, i, 2);
	}
	glPopMatrix();		
}
void DrawTrunk()
{
	branches.clear();

	// Add trunk to collision set
	Point3D start(0, 0, 0);
	Point3D end(0, 0, trunk_height);
	CylinderObj branch(start, end, trunk_rad, trunk_rad, trunk_fad * trunk_rad, trunk_height, 0, 0, 0, 0);

	// Draw Trunk
	DrawClosedCylinder(trunk_rad, trunk_fad * trunk_rad, trunk_height, 7, 7, &branch);
	branches.push_back(branch);

	// Draw Branches
	int branches = (int) RandDouble(2, 2);
	for(int i = 0; i < branches; i++) {
		float loc = 0.0;
		float radius = trunk_fad*trunk_rad;
		DrawBranch(radius, loc*trunk_height, i);
	}
}

void RepeatTree()
{
	// Recall that DrawClosedCylinder also incorporates with it an implicit
	// glTranslatef(0.0f,0.0f,height);

	int curlevel;
	int status = 0;
	for(int i = 0; i < branches.size(); i++)
	{
		// Trunk
		if(i == 0) {
			GLdouble matrix[16];
			glGetDoublev(GL_MODELVIEW_MATRIX, matrix);
			DrawClosedCylinder(branches[0].r_bottom, branches[0].r_top, branches[0].height, 7, 7, &branches[i]);
			glGetDoublev(GL_MODELVIEW_MATRIX, matrix);
			curlevel = 0;
		}
		else
		{
			int branch_level = branches[i].level;
			int level_diff = curlevel - branch_level;
			while(level_diff >= 0){
				glPopMatrix();
				status--;
				level_diff--;
			}
			glPushMatrix();
			status++;
			glTranslatef(0, 0, branches[i].translate);
			float rotate1 = branches[i].rotate;
			float rotate2 = branches[i].rotate2;
			glRotatef(rotate1, 0, 1, 0);
			glRotatef(rotate2, 1, 0, 0);
			assert(status == branches[i].level);
			DrawClosedCylinder(branches[i].r_bottom, branches[i].r_top, branches[i].height, 7, 7, &branches[i]);
			curlevel = branches[i].level;
		}
	}
	int branch_level = branches[branches.size()-1].level;
	while(branch_level > 0)
	{
		glPopMatrix();
		status--;
		branch_level--;
	}
	assert(status == 0);
}

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
	//if(!firstDraw) return TRUE;
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();							// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f*zoomFactor,(GLfloat)640/(GLfloat)480,0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();									// Reset The View
	gluLookAt(0, up, out, 0, 0, 0, 0, 1, 0);
	glTranslatef(0.0f,0.0f,z);
	glRotatef(270,1.0f,0.0f,0.0f);
	glRotatef(zrot, 1.0f, 0.0f, 0.0f);
	glRotatef(crot, 0.0f, 0.0f, 1.0f);
	
	glBindTexture(GL_TEXTURE_2D, textureNum);
	
	glTranslatef(0.0f,0.0f,ydown);					// Center The Cylinder
	if(showCylinder){
#ifdef OUTPUT
		//showCylinder = false;
#endif
		// Trunk
		if(firstDraw) {
			DrawTrunk();
			firstDraw = false;
			firstTime = true;
		
		}
		else
		{
			RepeatTree();
			if(output && firstTime == false)
			{
				output = false;
				fprintf(file, "] ");
				fclose(file);
				fprintf(file2, "]");
				fclose(file2);
				fprintf(file3, "]");
				fclose(file3);
				fprintf(file4, "]");
				fclose(file4);
				fclose(file5);
			}
		
		}
	}
	return TRUE;										// Keep Going
}

void DrawClosedCylinder(float rad_b, float rad_t, float height, float slice, float scale, CylinderObj * obj)
{
	Cylinder(quadratic,rad_b,rad_t,height,slice,scale, obj);	// A Cylinder With A Radius Of 0.1 And A Height Of 1
	Disk(quadratic,0.0f,rad_b,2,2);
	glTranslatef(0.0f,0.0f,height);
	Disk(quadratic,0.0f,rad_t,2,2);	
}
GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	gluDeleteQuadric(quadratic);						// Delete The Quadratic To Free System Resources

	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	fullscreen = FALSE;

	// Create Our OpenGL Window
	if (!CreateGLWindow("Procedural Tree",640,480,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
			{
				done=TRUE;							// ESC or DrawGLScene Signalled A Quit
			}
			else									// Not Time To Quit, Update Screen
			{
				SwapBuffers(hDC);					// Swap Buffers (Double Buffering)
				if (keys['F'] && !fp)
				{
					fp=TRUE;
					filter+=1;
					if (filter>2)
					{
						filter=0;
					}
				}
				if (!keys['F'])
				{
					fp=FALSE;
				}
				if (keys[' '] && !sp)
				{
					sp=TRUE;
					object++;
					if(object>5)
						object=0;
				}
				if (!keys[' '])
				{
					sp=FALSE;
				}
				if (keys[VK_PRIOR])
				{
					z-=0.02f;
				}
				if (keys[VK_NEXT])
				{
					z+=0.02f;
				}
				if(keys[VK_UP])
				{
					zoomFactor-=.01f;
				}
				if(keys[VK_DOWN])
				{
					zoomFactor+=.01f;
				}
				if(keys['C'])
				{
					showCylinder = false;
				}
				if(keys['V'])
				{
					showCylinder = true;
				}
				if(keys['N'])
				{
					firstDraw = true;
				}
				if (keys[VK_RIGHT])
				{
					crot+=5;
				}
				if (keys[VK_LEFT])
				{
					crot-=5;
				}
				if (keys['W'])
				{
					up+=.1f;
				}
				if (keys['S'])
				{
					up-=.1f;
				}
				if (keys['A'])
				{
					out+=.1f;
				}
				if (keys['D'])
				{
					out-=.1f;
				}
				if (keys['P'])
				{
					total_vertex = 0;
					output = TRUE;
				}
				if (keys['O'])
				{
					ydown+=3;
				}
				if (keys['L'])
				{
					ydown-=3;
				}

				if (keys[VK_F1])						// Is F1 Being Pressed?
				{
					keys[VK_F1]=FALSE;					// If So Make Key FALSE
					KillGLWindow();						// Kill Our Current Window
					fullscreen=!fullscreen;				// Toggle Fullscreen / Windowed Mode
					// Recreate Our OpenGL Window
					if (!CreateGLWindow("NeHe & TipTup's Quadratics Tutorial",640,480,16,fullscreen))
					{
						return 0;						// Quit If Window Was Not Created
					}
				}
			}
		}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}
